// VTC1021 API V1.5 2017/05/22
#define VTC1021_API extern "C" __declspec(dllimport)


const unsigned int g_phone_number_Len = 20;
typedef struct Phone_Number
{
	char phone_number[g_phone_number_Len];		// 
} Phone_Number_t;

typedef struct Phone_Number_W
{
	wchar_t phone_number[g_phone_number_Len];	// 
} Phone_Number_W_t;


VTC1021_API void Get_DLL_Version(int *pnMajorVersion, int *pnMinorVersion);
VTC1021_API bool Get_BIOS_Version(char *szBIOS_Ver, int nLen);
VTC1021_API bool Get_BIOS_Version_W(wchar_t *szBIOS_Ver, int nLen);

VTC1021_API int Connect();
VTC1021_API void Disconnect();

VTC1021_API int  GetMCUVersion(int *pnMCUVersion);
VTC1021_API int  GetIgnitionStatus(int *pnIgnitionStatus);
VTC1021_API int  GetSupplyVoltage(int *pnSupplyVoltage);
VTC1021_API int  GetPowerType(int *pnPowerType);
VTC1021_API int  GetDelayTimeOption(int *pnPowerOff, int *pnPowerOn, int *pnDelayOffEnable, int *pnDelayOnEnable);
VTC1021_API int  GetStartupShutdownOption(int *pnStartupShutdownOption);
VTC1021_API int  GetAlarmTimer(int *pnHour, int *pnMin, int *pnSec);
VTC1021_API int  GetWWANStatus(int *pnWWAN_Enable, int *pnWWAN_Wakeup_Enable);
VTC1021_API int  GetWiFiStatus(int *pnWiFi_En1, int *pnWiFi_En2, int *pnWiFi_Pw1, int *pnWiFi_Pw2);
VTC1021_API int  GetBTStatus(int *pnBTStatus);
VTC1021_API int  GetGPSStatus(int *pnGPSStatus);
VTC1021_API int  GetRTCStatus(int *pnRTCStatus);
VTC1021_API int  GetWatchdogConfig(int *pnWDT_Enable, int *pnTimeout);
VTC1021_API int  GetMDOStatus(int *pnMDO1, int *pnMDO2, int *pnMDO3);
VTC1021_API int  GetMDIStatus(int *pnMDI1, int *pnMDI2, int *pnMDI3);
VTC1021_API int  GetGsensorData(int nRegisterIndex, unsigned char *pbyGsensorData, int nGsensorDataLen);
VTC1021_API int  GetInputFrequency(int *pnInputFrequency);
VTC1021_API int  GetSIMCardStatus(int *pnSIMCard);
VTC1021_API int  GetWakeOnLanStatus(int *pnWakeOnLanStatus);
VTC1021_API int  GetCANIMPStatus(int *pnCANIMPStatus);

VTC1021_API int  SetRTCTimer(int nHour, int nMin, int nSec);
VTC1021_API int  SetDelayTimeOption(int nPowerOffDelayTime, int nPowerOffDelayTime_Enable, int nPowerOnDelayTime, int nPowerOnDelayTime_Enable);
VTC1021_API int  SetStartupShutdownOption(int nOption);
VTC1021_API int  SetAlarmTimer(int nHour, int nMin, int nSec);
VTC1021_API int  SetWWANControl(int nWWAN_Enable, int nWWAN_Wakeup_Enable);
VTC1021_API int  SetWiFiControl(int nWiFi_En1, int nWiFi_En2, int nWiFi_Pw1, int nWiFi_Pw2);
VTC1021_API int  SetBTControl(int nBT);
VTC1021_API int  SetGPSControl(int nEnable);
VTC1021_API int  SetRTCControl(int nEnable);
VTC1021_API int  SetWatchdogControl(int nWDT_Enable);
VTC1021_API int  SetWatchdogTimer(int nWDT_TimeOut);
VTC1021_API int  SetFlashUpdate();
VTC1021_API int  SetMDOControl(int nMDO1, int nMDO2, int nMDO3);
VTC1021_API int  SetGsensorData(int nRegIdx, unsigned char *pbyData, int nLen);
VTC1021_API int  SetSIMCardSelect(int nSIMCardSelect);
VTC1021_API int  SetWakeOnLanControl(int nEnable);
VTC1021_API int  SetCANIMPControl(int nEnable);

VTC1021_API int  Get3GAPN(char *pszAPN, int nLen);
VTC1021_API int  Get3GAPN_W(wchar_t *pszAPN, int nLen);
VTC1021_API int  Get3GDNS(int nIndex, char *pszDNS, int nLen);
VTC1021_API int  Get3GDNS_W(int nIndex, wchar_t *pszDNS, int nLen);
VTC1021_API int  Get3GServerIP(char *pszServerIP, int nLen);
VTC1021_API int  Get3GServerIP_W(wchar_t *pszServerIP, int nLen);
VTC1021_API int  Get3GServerPort(int *pnServerPort);
VTC1021_API int  GetIMEI(char *pszIMEI, int nLen);
VTC1021_API int  GetIMEI_W(wchar_t *pszIMEI, int nLen);
VTC1021_API int  GetMachineName(char *pszName, int nLen);
VTC1021_API int  GetMachineName_W(wchar_t *pszName, int nLen);
VTC1021_API int  GetPhoneNumber(int nIndex, Phone_Number_t *pPhone_Number, int nCount);
VTC1021_API int  GetPhoneNumber_W(int nIndex, Phone_Number_W_t *pPhone_Number, int nCount);
VTC1021_API int  GetTrackerStatus(int *pnTracker_Enable);
VTC1021_API int  GetTrackerMode(int *pnTrackerMode);
VTC1021_API int  GetTrackerDelayTime(int *pnDelayTime);
VTC1021_API int  GetTrackerResponseTime(int *pnResponseTime);
VTC1021_API int  GetTrackerThreshtap(int *pnTrackerThreshtap);
VTC1021_API int  GetTrackerAngle(int *pnTrackerAngle);
VTC1021_API int  GetSMSStatus(int *pnSMS_Enable);
VTC1021_API int  GetSMSCodingType(int *pnType);
VTC1021_API int  GetSMSContent_ASCII(char *pszSMS, int nLen);
VTC1021_API int  GetSMSContent_ASCII_W(wchar_t *pszSMS, int nLen);
VTC1021_API int  GetSMSContent_Unicode(wchar_t *pszSMS, int nLen);

VTC1021_API int  Set3GAPN(char *pszAPN, int nLen);
VTC1021_API int  Set3GAPN_W(wchar_t *pszAPN, int nLen);
VTC1021_API int  Set3GDNS(int nIndex, char *pszDNS, int nLen);
VTC1021_API int  Set3GDNS_W(int nIndex, wchar_t *pszDNS, int nLen);
VTC1021_API int  SetServerIP(char *pszIP, int nLen);
VTC1021_API int  SetServerIP_W(wchar_t *pszIP, int nLen);
VTC1021_API int  SetServerPort(int nPort);
VTC1021_API int  SetMachineName(char *pszMachineName, int nLen);
VTC1021_API int  SetMachineName_W(wchar_t *pszMachineName, int nLen);
VTC1021_API int  SetPhoneNumber(int nIndex, Phone_Number_t *pPhone_Number, int nCount);
VTC1021_API int  SetPhoneNumber_W(int nIndex, Phone_Number_W_t *pPhone_Number, int nCount);
VTC1021_API int  SetTrackerControl(int nTrackerEnable);
VTC1021_API int  SetTrackerMode(int nTrackerMode);
VTC1021_API int  SetTrackerDelayTime(int nTime);
VTC1021_API int  SetTrackerResponseTime(int nTime);
VTC1021_API int  SetTrackerThreshtap(int nThreshtap);
VTC1021_API int  SetTrackerAngle(int nTrackerAngle);
VTC1021_API int  SetSMSControl(int nSMS_Enable);
VTC1021_API int  SetSMSCodingType(int nSMSCodingType);
VTC1021_API int  SetSMSContent_ASCII(char *pszSMS, int nLen);
VTC1021_API int  SetSMSContent_ASCII_W(wchar_t *pszSMS, int nLen);
VTC1021_API int  SetSMSContent_Unicode(wchar_t *pszSMS, int nLen);

VTC1021_API int  GetBackupBatteryStatus(int *pnBatteryStatus);
VTC1021_API int  GetSmartBatteryVoltage(int *pnBatteryVoltage);
VTC1021_API int  GetSmartBatteryTemperature(int *pnBatteryTemperature);
VTC1021_API int  GetSmartBatteryCapacity(int *pnBatteryCapacity);

// ================================================================================================================================================
typedef void (*EventSystemAlarm_CallBack)(unsigned char byAlarm);

VTC1021_API void RegisterSystemAlarmCallBackFunction(
	EventSystemAlarm_CallBack fnESA);

typedef void (*BackupBatteryAlarm_CallBack)(unsigned char byAlarm);

VTC1021_API void RegisterBatteryCallBackFunction(
	BackupBatteryAlarm_CallBack  fnBBA);
